declare variable $inputDocument external;
declare variable $root := doc($inputDocument)/*;

 <channel baseUrl="{data($root/@xml:base)}">{$root/@*}
    {
    for $node in  $root/*
    return
         if (name($node) = "channel")
         then
             for $x in $node/*
             return
             if ((namespace-uri($x) eq "http://channel.netscape.com/rdf/simple/0.9/") or (namespace-uri($x) eq "http://purl.org/rss/1.0/")
		 or (namespace-uri($x) eq "http://my.netscape.com/rdf/simple/0.9/"))
                then if (name($x) = "title")
                then <title>{string($x)}</title>
                else if (name($x) = "link")
                then <link>{string($x)}</link>
                else if (name($x) = "description")
                then <description>{string($x)}</description>
                else ()             (: End of all channel details:)
              else $x   (: other namespace nodes in channel :)

            else if (name($node) = "image")  (: Check for channel icon :)
            then
                  for $x in $node/*
                  return
                     if(name ($x) = "url")
                    then <image>{ string($x) } </image>
                    else ()

            else if (name($node) = "item")
            then
                <message baseUrl="{data($node/@xml:base)}">
                {
                for $x in $node/*
                return
                if ((namespace-uri($x) eq "http://channel.netscape.com/rdf/simple/0.9/") or (namespace-uri($x) eq "http://purl.org/rss/1.0/")
		    or (namespace-uri($x) eq "http://my.netscape.com/rdf/simple/0.9/"))
                    then if (name($x) = "title")
                    then <title>{string($x)}</title>
                    else if (name($x) = "link")
                    then <link>{string($x)}</link>
                    else if (name($x) = "description")
                    then <description baseUrl="{data($x/@xml:base)}">{($x/node())}</description>
                    else ()     (: Unhandled item tags :)
                else $x     (: other namespace node in item :)
               }
               </message>

         else ()    (: Any other tags apart from channel and item are ignored :)

      }
</channel>
